#!/bin/bash
#
#   Hitachi Fibre Channel Adapter Driver Installer for Linux IA32/IA64
#
#   $Header: /home/cvs_linux/hfclinux/hfcinst.sh.as4,v 1.5 2005/11/25 06:10:06 eteshima Exp $
#   $Log: hfcinst.sh.as4,v $
#   Revision 1.5  2005/11/25 06:10:06  eteshima
#   add depmod -a
#
#   Revision 1.4  2005/11/25 06:05:29  eteshima
#   modify hfcldd.o to hfcldd.ko
#
#   Revision 1.3  2005/11/02 06:54:37  eteshima
#   check in miss
#
#   Revision 1.2  2005/11/02 04:55:38  eteshima
#   backup current hfcldd files to *.backup
#
#   Revision 1.1  2005/09/14 03:06:19  eteshima
#   as4 support
#
#   Revision 1.3  2005/04/13 13:23:28  eteshima
#   check rmmod return value
#
#   Revision 1.2  2005/04/13 13:00:45  eteshima
#   add header
#
#   Revision 1.3   2005/02/03  IA64 support
#   Revision 1.2   2004/12/15  Check whether module is loaded at the issuing insmod cmd
#   Revision 1.1   2004/12/14  New release
#
# $1: install   -> install
#     uninstall -> uninstall
# $2: Kernel Version  ex. 2.4.21-4EL
#   : NULL -> Kernel Version = `uname -r`
#
if [ "$1" != "install" -a "$1" != "uninstall" ]; then
        echo "Usage : hfcinst.sh install/uninstall [Kernel-Version]"
        echo "example(install  ) : hfcinst.sh install"
        echo "       (uninstall) : hfcinst.sh uninstall"
        exit 1
fi
DRVDIR="drivers"
DRVNAME="hfcldd.ko"
DRVMODU="hfcldd"
HFCMKNOD="hfcmknod"
HOSTTYPE=$(uname -m)
TOOLSDIR="/opt/hitachi/drivers/hba"
MODULESCONF="modprobe.conf"
if [ "$HOSTTYPE" = "ia64" ]; then
	BOOTDIR="boot/efi/efi/redhat"
else
	BOOTDIR="boot"
fi
echo " boot directory is $BOOTDIR"
if [ -n "$2" ]; then
    KERNVER=$2
else
    KERNVER=`uname -r`
fi
LIBMODULE="/lib/modules/$KERNVER/kernel/drivers"
if [ ! -d "$LIBMODULE" ]; then
    echo " @ERR install directry($LIBMODULE) not found"
    if [ -n "$2" ]; then
        echo "      Kernel $2 not installed."
    fi
    exit 1
fi
echo "      Kernel version      : $KERNVER"
echo "      Host Type           : `uname -m`"
if [ "$1" = "install" ]; then
    echo " ---- Install  @Hitachi Fibre Channel Adapter Driver "
    echo "        backup current hfcldd files to *.backup"
    find /lib/modules/$KERNVER -name hfcldd.ko -exec mv {} {}.backup \;
    echo "        install -d -o root -g root $LIBMODULE/scsi/"
    install -d -o root -g root $LIBMODULE/scsi/
    echo "        install -o root -g root $DRVDIR/$KERNVER/$DRVNAME $LIBMODULE/scsi/" 
    install -o root -g root $DRVDIR/$KERNVER/$DRVNAME $LIBMODULE/scsi/
    if [ ! -f "$LIBMODULE/scsi/$DRVNAME" ]; then
        echo " @ERR install command failed."
        exit 1
    fi
    echo "      Modify /etc/$MODULESCONF; old file is /etc/$MODULESCONF.backup"
    cp /etc/$MODULESCONF /etc/$MODULESCONF.backup
    if [ `grep -c "scsi_hostadapter[0-9]*[[:space:]]\+hfcldd" /etc/$MODULESCONF` -eq 0 ]; then
        COUNT=`grep -c "scsi_hostadapter" /etc/$MODULESCONF`
        if [ $COUNT -eq 0 ]; then
            echo "alias scsi_hostadapter hfcldd" >> /etc/$MODULESCONF
        elif [ $COUNT -eq 1 ]; then
            if [ `grep -c "scsi_hostadapter0" /etc/$MODULESCONF` -eq 0 ]; then
                LN=`sed -n /scsi_hostadapter/{=} /etc/$MODULESCONF`
                sed s/scsi_hostadapter/scsi_hostadapter0/ /etc/$MODULESCONF > /etc/$MODULESCONF.temp
                mv /etc/$MODULESCONF.temp /etc/$MODULESCONF
                LN=`expr $LN + 1`
                sed "$LN"i"alias scsi_hostadapter$COUNT hfcldd" /etc/$MODULESCONF > /etc/$MODULESCONF.temp
                mv /etc/$MODULESCONF.temp /etc/$MODULESCONF
            else
                LN=`sed -n /scsi_hostadapter0/{=} /etc/$MODULESCONF`
                LN=`expr $LN + 1`
                sed "$LN"i"alias scsi_hostadapter$COUNT hfcldd" /etc/$MODULESCONF > /etc/$MODULESCONF.temp
                mv /etc/$MODULESCONF.temp /etc/$MODULESCONF
            fi
        else
            COUNT=`expr $COUNT - 1`
            LN=`sed -n /scsi_hostadapter$COUNT/{=} /etc/$MODULESCONF`
            LN=`expr $LN + 1`
            COUNT=`expr $COUNT + 1`
            sed "$LN"i"alias scsi_hostadapter$COUNT hfcldd" /etc/$MODULESCONF > /etc/$MODULESCONF.temp
            mv /etc/$MODULESCONF.temp /etc/$MODULESCONF
        fi
    fi
#    if [ `grep -c "max_scsi_luns" /etc/$MODULESCONF` -eq 0 ]; then
#       echo "options scsi_mod max_scsi_luns=128" >> /etc/$MODULESCONF
#    fi
    cp /$BOOTDIR/initrd-$KERNVER.img /$BOOTDIR/initrd-$KERNVER.img.backup
    echo "        /sbin/depmod -a"
    /sbin/depmod -a
    echo "      Update boot image file /$BOOTDIR/initrd-$KERNVER.img"
    echo "      old boot image file --> /$BOOTDIR/initrd-$KERNVER.img.backup"
    echo "        /sbin/mkinitrd -f /$BOOTDIR/initrd-$KERNVER.img $KERNVER"
    /sbin/mkinitrd -f /$BOOTDIR/initrd-$KERNVER.img $KERNVER
    if [ $? -ne 0 ]; then
        echo " @ERR mkinitrd command fail"
        cp /$BOOTDIR/initrd-$KERNVER.img.backup /$BOOTDIR/initrd-$KERNVER.img
        rm -f /$BOOTDIR/initrd-$KERNVER.img.backup
        exit 1
    fi 
    if [ "$KERNVER" = `uname -r` ]; then
        echo "      check loaded modules"
        if [ `/sbin/lsmod | grep hfcldd | wc -l` -eq 0 ]; then
            echo "        /sbin/modprobe $DRVMODU"
            /sbin/modprobe $DRVMODU 
            if [ $? -eq 1 ]; then
                echo " @ERR modprobe command fail"
                exit 1
            fi
        else
            echo "      A module named hfcldd already exists"
            echo "      Skip modprobe. Need reload a module again or reboot to update"
        fi
        echo "      Make special file"
        ./hfcmknod 
        if [ $? -ne 0 ]; then
            exit 1
        fi      
    fi
    install -d -o root -g root $TOOLSDIR     
    install -o root -g root tools/* $TOOLSDIR
    install -o root -g root $HFCMKNOD /etc/init.d/
    /sbin/chkconfig --add hfcmknod
    echo " ---- Install Success "
else
    echo " ---- Uninstall  @Hitachi Fibre Channel Adapter Driver "
    echo "        rm -f $LIBMODULE/scsi/$DRVNAME" 
    rm -f $LIBMODULE/scsi/$DRVNAME
    echo "      Modify /etc/$MODULESCONF"
    cp /etc/$MODULESCONF /etc/$MODULESCONF.temp
    sed '/alias scsi_hostadapter.* hfcldd/d' /etc/$MODULESCONF.temp > /etc/$MODULESCONF
    rm /etc/$MODULESCONF.temp
    echo "        /sbin/mkinitrd -f /$BOOTDIR/initrd-$KERNVER.img $KERNVER"
    cp /$BOOTDIR/initrd-$KERNVER.img /$BOOTDIR/initrd-$KERNVER.img.backup
    /sbin/mkinitrd -f /$BOOTDIR/initrd-$KERNVER.img $KERNVER
    if [ $? -ne 0 ]; then
        echo " @ERR mkinitrd command fail"
        cp /$BOOTDIR/initrd-$KERNVER.img.backup /$BOOTDIR/initrd-$KERNVER.img
        exit 1
    fi 
    if [ "$KERNVER" = `uname -r` ]; then
        echo "        /sbin/rmmod $DRVMODU"
        /sbin/rmmod $DRVMODU 
        if [ $? -eq 1 ]; then
           echo " @ERR rmmod command fail"
           exit 1
        fi
        /etc/init.d/hfcmknod stop 
        if [ $? -ne 0 ]; then
            exit 1
        fi      
    fi 
    /sbin/chkconfig --del hfcmknod
    rm -f /etc/init.d/$HFCMKNOD
    rm -f $TOOLSDIR/*
    echo " ---- Uninstall Success "
fi
